<script lang="ts">
  import { Input } from '@sveltestrap/sveltestrap';
  import Fa from 'svelte-fa';
  import Markdown from '@components/Markdown/Markdown.svelte';
  import { faPencil, faCheck } from '@fortawesome/free-solid-svg-icons';
  import { clickOutside } from 'sveltronics';
  import { createEventDispatcher } from 'svelte';
  import { getNotificationsContext } from 'svelte-notifications';

  const { addNotification } = getNotificationsContext();

  const dispatch = createEventDispatcher();

  export let text: string;
  export let multiline: boolean = false;
  export let minWidth: string = '';
  export let minHeight: string = '250px';
  export let showHelp: boolean = multiline;
  export let maxLength: number | undefined = undefined;
  export let minLength: number = 0;
  export let initialEditing: boolean = false;
  export let placeholder: string = '';
  export let hideOnClickOutside: boolean = true;
  export let alwaysEditing: boolean = false;
  export let lightText: boolean = false;

  // To prevent external edits from removing local data
  let internalText: string = text;

  let editing: boolean = initialEditing || alwaysEditing;
</script>

<div class="w-100 d-flex flex-row">
  <div
    class="flex-grow-1"
    use:clickOutside
    on:clickOutsideDispatch={() => {
      if (hideOnClickOutside && !alwaysEditing) editing = false;
    }}
  >
    {#if !editing}
      <div class="text-wrap text-break" on:click={() => (editing = true)}>
        <Markdown source={text || placeholder} />
      </div>
    {:else}
      <Input
        maxlength={maxLength}
        minlength={minLength}
        type={multiline ? 'textarea' : 'text'}
        style={`${minWidth ? `min-width: ${minWidth};` : ``}${
          multiline || minHeight ? `min-height: ${minHeight};` : ``
        }`}
        {placeholder}
        bind:value={internalText}
        on:change={() => {
          if (internalText.length >= minLength) {
            dispatch('save', internalText);
          } else {
            internalText = text;
            addNotification({
              text: `Must be at least ${minLength} character${minLength !== 1 ? 's' : ''}`,
              position: 'bottom-right',
              removeAfter: 2500,
              type: 'error',
            });
          }
        }}
      />
      {#if showHelp}
        <div class="text-{lightText ? 'light' : 'muted'}">
          <a href="https://commonmark.org/help/" rel="noopener noreferrer" target="_blank">Markdown</a> Formatting Supported
        </div>
      {/if}
    {/if}
  </div>
  {#if !alwaysEditing}
    <div class="mx-2 text-nowrap">
      {#if !editing}
        <button
          type="button"
          on:click={() => (editing = true)}
          class="btn btn-transparent btn-edit text-{lightText ? 'light' : 'muted'}"
        >
          <Fa icon={faPencil} /> Edit
        </button>
      {:else}
        <button type="button" on:click={() => (editing = false)} class="btn btn-success">
          <Fa icon={faCheck} /> Done
        </button>
      {/if}
    </div>
  {/if}
</div>
